#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>


/* se aprind pe rand, etajele 1,3,2*/
void etaje()
{
	PORTA = 0b11111111;
	PORTC = 0b00000001;
      
	_delay_ms(30000);
	PORTD = 0b00000100;
 
	_delay_ms(30000);
	PORTD = 0b00000010;

	_delay_ms(30000);
	PORTD = 0b00000001;
 
	_delay_ms(30000);
}

/*Se aprind LED-urile verzi, pentru fieare etaj, pe rand*/
void verde()
{
			
	/*tranzistorul PORD, pozitia 6, controleaza etajul de jos
	se aprind cele 2 LED-uri verzi de pe etajul de jos*/
	PORTD = 0b00000100;
	PORTA = 0b00100010;
	PORTC = 0b00000000;
	_delay_ms(3000);
		
	/*tranzistorul PORD, pozitia 8, controleaza etajul din mijloc
	se aprind cele 2 LED-uri verzi de pe etajul din mijloc*/
	PORTD = 0b00000001;
	PORTA = 0b10000000;
	PORTC = 0b00000001;
	_delay_ms(3000);
		
	/*tranzistorul PORD, pozitia 7, controleaza etajul de sus
	se aprinde LED-ul verde de pe etajul de sus*/
	PORTD = 0b00000010;
	PORTA = 0b00001000;
	PORTC = 0b00000000;
	_delay_ms(30000);		
	
}

/*Se aprind LED-urile rosii, pentru fieare etaj, pe rand*/
void rosu() 
{
	/*se aprind LED-urile rosii de pe etajul de jos*/
	PORTD = 0b00000100;
	PORTA = 0b11011101;
	PORTC = 0b00000001;
	_delay_ms(3000);
		
		/*se aprind LED-urile rosii de pe etajul din mijloc*/
	PORTD = 0b00000001;
	PORTA = 0b01111111;       
	PORTC = 0b00000000;
	_delay_ms(3000);
		
	/*se aprind LED-urile rosii de pe etajul de sus*/
	PORTD = 0b00000010;
	PORTA = 0b11110111;        
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
}

/*se aprind, pe rand, LED-urile unui etaj, in spirala*/
void spirala_1()
{	
	
	PORTA = 0b00000010;
	_delay_ms(3000);
	PORTA = 0b00010000;
	_delay_ms(3000);
	PORTA = 0b10000000;
	_delay_ms(3000);
	PORTA = 0b01000000;
	_delay_ms(3000);
	PORTA = 0b00100000;
	_delay_ms(3000);
	PORTA = 0b00000100;
	_delay_ms(3000);
	PORTC = 0b00000001;
	_delay_ms(3000);
	PORTC = 0b00000000;
	PORTA = 0b00000001;
	_delay_ms(3000);
	PORTA = 0b00001000;
	_delay_ms(3000);

}

void spirala_2()
{
		
	PORTA = 0b00001000;
	_delay_ms(3000);
	PORTA = 0b00000010;
	_delay_ms(3000);
	PORTA = 0b00010000;
	_delay_ms(3000);
	PORTA = 0b10000000;
	_delay_ms(3000);
	PORTA = 0b01000000;
	_delay_ms(3000);
	PORTA = 0b00100000;
	_delay_ms(3000);
	PORTA = 0b00000100;
	_delay_ms(3000);
	PORTC = 0b00000001;
	_delay_ms(3000);
	PORTC = 0b00000000;
	PORTA = 0b00000001;
	_delay_ms(3000);	

}

void i_love_you()
{
	PORTD = 0b00000010;
	
	PORTA = 0b01001001; // I
	_delay_ms(30000);	
	PORTA = 0b00000000;
	_delay_ms(300000);
	
	PORTA = 0b11010010; // L
	_delay_ms(30000);
	PORTA = 0b00000000;
	_delay_ms(30000);
	
	PORTA = 0b11110111; // O	
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(30000);
	
	PORTA = 0b01000010; // V
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(30000);
	
	PORTA = 0b11111011; // E
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(300000);
	
	PORTA = 0b01001010; // Y
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(30000);
	
	PORTA = 0b11110111; // O
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(30000);
	
	PORTA = 0b11110110; // U
	PORTC = 0b00000001;
	_delay_ms(30000);
	PORTC = 0b00000000;
	PORTA = 0b00000000;
	_delay_ms(300000);
	
}

int main() 
{

	/*se seteaza pinii de iesire*/
	DDRA = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;

	while (1) {
	
	   int i;	   

       for (i = 0; i < 2; i++) {
		
           etaje(); 
           
			
			verde();
			rosu();
			
			/*se aprinde etajul de sus in spirala*/
			PORTD = 0b00000010;
			spirala_1();
			
			/*se aprinde etajul din mijloc in spirala*/
			PORTD = 0b0000001;
			spirala_2();
		
			/*se aprinde etajul de jos in spirala*/
			PORTD = 0b0000100;
			spirala_1();
			
			/*se aprind coloanele in spirala*/
			PORTD = 0b00000111;			
			spirala_2();	
		
			i_love_you();
		
		}	
    }

}
